Package net.sf.saxon.type

## Enum AnySimpleType

- java.lang.Object
- - java.lang.Enum<AnySimpleType>
  - - net.sf.saxon.type.AnySimpleType

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<AnySimpleType>`, `SchemaComponent`, `SchemaType`, `SimpleType`

      public enum AnySimpleType
      extends java.lang.Enum<AnySimpleType>
      implements SimpleType

  This class has a singleton instance which represents the XML Schema built-in type xs:anySimpleType

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.SchemaComponent

      `SchemaComponent.ValidationStatus`

  - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `INSTANCE` |

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static StructuredQName` | `NAME` |

    - ### Fields inherited from interface net.sf.saxon.type.SchemaComponent

      `COMPONENT_FUNCTION_TYPE`

    - ### Fields inherited from interface net.sf.saxon.type.SchemaType

      `DERIVATION_EXTENSION, DERIVATION_LIST, DERIVATION_RESTRICTION, DERIVATION_UNION, DERIVE_BY_SUBSTITUTION`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `allowsDerivation​(int derivation)` | Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
    `void` | `analyzeContentExpression​(Expression expression, int kind)` | Analyze an expression to see whether the expression is capable of delivering a value of this type.
    `AtomicSequence` | `atomize​(NodeInfo node)` | Get the typed value of a node that is annotated with this schema type.
    `void` | `checkTypeDerivationIsOK​(SchemaType type, int block)` | Check that this type is validly derived from a given type
    `SchemaType` | `getBaseType()` | Get the base type
    `int` | `getBlock()` | Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`
    `SchemaType` | `getBuiltInBaseType()` | Get the built-in ancestor of this type in the type hierarchy
    `Function` | `getComponentAsFunction()` | Get the schema component in the form of a function item.
    `int` | `getDerivationMethod()` | Gets the integer code of the derivation method used to derive this type from its parent.
    `java.lang.String` | `getDescription()` | Get a description of this type for use in diagnostics
    `java.lang.String` | `getDisplayName()` | Get the display name of the type: that is, a lexical QName with an arbitrary prefix
    `java.lang.String` | `getEQName()` | Get the name of this type as an EQName, that is, a string in the format Q{uri}local.
    `int` | `getFinalProhibitions()` | Get the types of derivation that are not permitted, by virtue of the "final" property.
    `int` | `getFingerprint()` | Get the fingerprint of the name of this type
    `static AnySimpleType` | `getInstance()` | Get the singular instance of this class
    `java.lang.String` | `getName()` | Get the local name of this type
    `int` | `getRedefinitionLevel()` | Get the redefinition level.
    `StructuredQName` | `getStructuredQName()` | Get the name of the type as a StructuredQName
    `java.lang.String` | `getSystemId()` | Get the URI of the schema document containing the definition of this type
    `java.lang.String` | `getTargetNamespace()` | Get the target namespace of this type
    `AtomicSequence` | `getTypedValue​(java.lang.CharSequence value, NamespaceResolver resolver, ConversionRules rules)` | Get the typed value corresponding to a given string value, assuming it is valid against this type
    `SchemaComponent.ValidationStatus` | `getValidationStatus()` | Get the validation status - always valid
    `int` | `getWhitespaceAction()` | Determine how values of this simple type are whitespace-normalized.
    `boolean` | `isAnonymousType()` | Test whether this is an anonymous type
    `boolean` | `isAtomicType()` | Test whether this Simple Type is an atomic type
    `boolean` | `isBuiltInType()` | Determine whether this is a built-in type or a user-defined type
    `boolean` | `isComplexType()` | Test whether this SchemaType is a complex type
    `boolean` | `isIdRefType()` | Ask whether this type is an IDREF or IDREFS type.
    `boolean` | `isIdType()` | Ask whether this type is an ID type.
    `boolean` | `isListType()` | Determine whether this is a list type
    `boolean` | `isNamespaceSensitive()` | Test whether this type represents namespace-sensitive content
    `boolean` | `isSameType​(SchemaType other)` | Test whether this is the same type as another type.
    `boolean` | `isSimpleType()` | Test whether this SchemaType is a simple type
    `boolean` | `isUnionType()` | Determin whether this is a union type
    `java.lang.CharSequence` | `postprocess​(java.lang.CharSequence input)` | Reverse any pre-lexical facets, other than whitespace.
    `java.lang.CharSequence` | `preprocess​(java.lang.CharSequence input)` | Apply any pre-lexical facets, other than whitespace.
    `ValidationFailure` | `validateContent​(java.lang.CharSequence value, NamespaceResolver nsResolver, ConversionRules rules)` | Check whether a given input string is valid according to this SimpleType
    `static AnySimpleType` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static AnySimpleType[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.type.SchemaType

      `getNearestNamedType`

- - ### Enum Constant Detail

    - #### INSTANCE

          public static final AnySimpleType INSTANCE

  - ### Field Detail

    - #### NAME

          public static final StructuredQName NAME

  - ### Method Detail

    - #### values

          public static AnySimpleType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (AnySimpleType c : AnySimpleType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static AnySimpleType valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getName

          public java.lang.String getName()

      Get the local name of this type
      Specified by:
        `getName` in interface `SchemaType`
      Returns:
        the local name of this type definition, if it has one. Return null in the case of an anonymous type.

    - #### getTargetNamespace

          public java.lang.String getTargetNamespace()

      Get the target namespace of this type
      Specified by:
        `getTargetNamespace` in interface `SchemaType`
      Returns:
        the target namespace of this type definition, if it has one. Return null in the case of an anonymous type, and in the case of a global type defined in a no-namespace schema.

    - #### getEQName

          public java.lang.String getEQName()

      Get the name of this type as an EQName, that is, a string in the format Q{uri}local.
      Specified by:
        `getEQName` in interface `SchemaType`
      Returns:
        an EQName identifying the type. In the case of an anonymous type, an internally-generated name is returned

    - #### isBuiltInType

          public boolean isBuiltInType()

      Determine whether this is a built-in type or a user-defined type
      Specified by:
        `isBuiltInType` in interface `SimpleType`
      Returns:
        true if this is a built-in type

    - #### isIdType

          public boolean isIdType()

      Ask whether this type is an ID type. This is defined to be any simple type who typed value may contain atomic values of type xs:ID: that is, it includes types derived from ID by restriction, list, or union. Note that for a node to be treated as an ID, its typed value must be a *single* atomic value of type ID; the type of the node, however, can still allow a list.
      Specified by:
        `isIdType` in interface `SchemaType`
      Returns:
        true if this type is an ID type

    - #### isIdRefType

          public boolean isIdRefType()

      Ask whether this type is an IDREF or IDREFS type. This is defined to be any simple type who typed value may contain atomic values of type xs:IDREF: that is, it includes types derived from IDREF or IDREFS by restriction, list, or union
      Specified by:
        `isIdRefType` in interface `SchemaType`
      Returns:
        true if this type is an IDREF type

    - #### getRedefinitionLevel

          public int getRedefinitionLevel()

      Get the redefinition level. This is zero for a component that has not been redefined; for a redefinition of a level-0 component, it is 1; for a redefinition of a level-N component, it is N+1. This concept is used to support the notion of "pervasive" redefinition: if a component is redefined at several levels, the top level wins, but it is an error to have two versions of the component at the same redefinition level.
      Specified by:
        `getRedefinitionLevel` in interface `SchemaComponent`
      Returns:
        the redefinition level

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the URI of the schema document containing the definition of this type
      Specified by:
        `getSystemId` in interface `SchemaType`
      Returns:
        null for a built-in type

    - #### getInstance

          public static AnySimpleType getInstance()

      Get the singular instance of this class
      Returns:
        the singular object representing xs:anyType

    - #### getValidationStatus

          public SchemaComponent.ValidationStatus getValidationStatus()

      Get the validation status - always valid
      Specified by:
        `getValidationStatus` in interface `SchemaComponent`
      Returns:
        one of the values `SchemaComponent.ValidationStatus.UNVALIDATED`, `SchemaComponent.ValidationStatus.VALIDATING`, `SchemaComponent.ValidationStatus.VALIDATED`, `SchemaComponent.ValidationStatus.INVALID`, `SchemaComponent.ValidationStatus.INCOMPLETE`

    - #### getBaseType

          public SchemaType getBaseType()

      Get the base type
      Specified by:
        `getBaseType` in interface `SchemaType`
      Returns:
        AnyType

    - #### isComplexType

          public boolean isComplexType()

      Test whether this SchemaType is a complex type
      Specified by:
        `isComplexType` in interface `SchemaType`
      Returns:
        true if this SchemaType is a complex type

    - #### isSimpleType

          public boolean isSimpleType()

      Test whether this SchemaType is a simple type
      Specified by:
        `isSimpleType` in interface `SchemaType`
      Returns:
        true if this SchemaType is a simple type

    - #### getFingerprint

          public int getFingerprint()

      Get the fingerprint of the name of this type
      Specified by:
        `getFingerprint` in interface `SchemaType`
      Returns:
        the fingerprint.

    - #### getStructuredQName

          public StructuredQName getStructuredQName()

      Get the name of the type as a StructuredQName
      Specified by:
        `getStructuredQName` in interface `SchemaType`
      Returns:
        a StructuredQName identifying the type. In the case of an anonymous type, an internally-generated name is returned

    - #### getDescription

          public java.lang.String getDescription()

      Get a description of this type for use in diagnostics
      Specified by:
        `getDescription` in interface `SchemaType`
      Returns:
        the string "xs:anyType"

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the display name of the type: that is, a lexical QName with an arbitrary prefix
      Specified by:
        `getDisplayName` in interface `SchemaType`
      Returns:
        a lexical QName identifying the type

    - #### isSameType

          public boolean isSameType​(SchemaType other)

      Test whether this is the same type as another type. They are considered to be the same type if they are derived from the same type definition in the original XML representation (which can happen when there are multiple includes of the same file)
      Specified by:
        `isSameType` in interface `SchemaType`
      Parameters:
        `other` - the other type
      Returns:
        true if this is the same type as other

    - #### atomize

          public AtomicSequence atomize​(NodeInfo node)

      Get the typed value of a node that is annotated with this schema type.
      Specified by:
        `atomize` in interface `SchemaType`
      Parameters:
        `node` - the node whose typed value is required
      Returns:
        the typed value.
      Since:
        8.5

    - #### checkTypeDerivationIsOK

          public void checkTypeDerivationIsOK​(SchemaType type,
                                              int block)
                                       throws SchemaException

      Check that this type is validly derived from a given type
      Specified by:
        `checkTypeDerivationIsOK` in interface `SchemaType`
      Parameters:
        `type` - the type from which this type is derived
        `block` - the derivations that are blocked by the relevant element declaration
      Throws:
        `SchemaException` - if the derivation is not allowed

    - #### isAtomicType

          public boolean isAtomicType()

      Test whether this Simple Type is an atomic type
      Specified by:
        `isAtomicType` in interface `SchemaType`
      Specified by:
        `isAtomicType` in interface `SimpleType`
      Returns:
        false, this is not (necessarily) an atomic type

    - #### isAnonymousType

          public boolean isAnonymousType()

      Description copied from interface: `SchemaType`
      Test whether this is an anonymous type
      Specified by:
        `isAnonymousType` in interface `SchemaType`
      Returns:
        true if this SchemaType is an anonymous type

    - #### isListType

          public boolean isListType()

      Determine whether this is a list type
      Specified by:
        `isListType` in interface `SimpleType`
      Returns:
        false (it isn't a list type)

    - #### isUnionType

          public boolean isUnionType()

      Determin whether this is a union type
      Specified by:
        `isUnionType` in interface `SimpleType`
      Returns:
        false (it isn't a union type)

    - #### getBuiltInBaseType

          public SchemaType getBuiltInBaseType()

      Get the built-in ancestor of this type in the type hierarchy
      Specified by:
        `getBuiltInBaseType` in interface `SimpleType`
      Returns:
        this type itself

    - #### getTypedValue

          public AtomicSequence getTypedValue​(java.lang.CharSequence value,
                                              NamespaceResolver resolver,
                                              ConversionRules rules)

      Get the typed value corresponding to a given string value, assuming it is valid against this type
      Specified by:
        `getTypedValue` in interface `SimpleType`
      Parameters:
        `value` - the string value
        `resolver` - a namespace resolver used to resolve any namespace prefixes appearing in the content of values. Can supply null, in which case any namespace-sensitive content will be rejected.
        `rules` - rules used for type conversion
      Returns:
        an iterator over the atomic sequence comprising the typed value. The objects returned by this SequenceIterator will all be of type `AtomicValue`

    - #### validateContent

          public ValidationFailure validateContent​(java.lang.CharSequence value,
                                                   NamespaceResolver nsResolver,
                                                   ConversionRules rules)

      Check whether a given input string is valid according to this SimpleType
      Specified by:
        `validateContent` in interface `SimpleType`
      Parameters:
        `value` - the input string to be checked
        `nsResolver` - a namespace resolver used to resolve namespace prefixes if the type is namespace sensitive. The value supplied may be null; in this case any namespace-sensitive content will throw an UnsupportedOperationException.
        `rules` - rules used for type conversion
      Returns:
        null if validation succeeds (which it always does for this implementation)
      Throws:
        `java.lang.UnsupportedOperationException` - if the type is namespace-sensitive and no namespace resolver is supplied

    - #### isNamespaceSensitive

          public boolean isNamespaceSensitive()

      Test whether this type represents namespace-sensitive content
      Specified by:
        `isNamespaceSensitive` in interface `SimpleType`
      Returns:
        false

    - #### getBlock

          public int getBlock()

      Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`
      Specified by:
        `getBlock` in interface `SchemaType`
      Returns:
        the value of the 'block' attribute for this type

    - #### getDerivationMethod

          public int getDerivationMethod()

      Gets the integer code of the derivation method used to derive this type from its parent. Returns zero for primitive types.
      Specified by:
        `getDerivationMethod` in interface `SchemaType`
      Returns:
        a numeric code representing the derivation method, for example `SchemaType.DERIVATION_RESTRICTION`

    - #### allowsDerivation

          public boolean allowsDerivation​(int derivation)

      Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
      Specified by:
        `allowsDerivation` in interface `SchemaType`
      Parameters:
        `derivation` - the kind of derivation, for example `SchemaType.DERIVATION_LIST`
      Returns:
        true if this kind of derivation is allowed

    - #### getFinalProhibitions

          public int getFinalProhibitions()

      Get the types of derivation that are not permitted, by virtue of the "final" property.
      Specified by:
        `getFinalProhibitions` in interface `SchemaType`
      Returns:
        the types of derivation that are not permitted, as a bit-significant integer containing bits such as `SchemaType.DERIVATION_EXTENSION`

    - #### getWhitespaceAction

          public int getWhitespaceAction()

      Determine how values of this simple type are whitespace-normalized.
      Specified by:
        `getWhitespaceAction` in interface `SimpleType`
      Returns:
        one of `Whitespace.PRESERVE`, `Whitespace.COLLAPSE`, `Whitespace.REPLACE`.

    - #### analyzeContentExpression

          public void analyzeContentExpression​(Expression expression,
                                               int kind)

      Analyze an expression to see whether the expression is capable of delivering a value of this type.
      Specified by:
        `analyzeContentExpression` in interface `SchemaType`
      Parameters:
        `expression` - the expression that delivers the content
        `kind` - the node kind whose content is being delivered: `Type.ELEMENT`, `Type.ATTRIBUTE`, or `Type.DOCUMENT`

    - #### preprocess

          public java.lang.CharSequence preprocess​(java.lang.CharSequence input)

      Apply any pre-lexical facets, other than whitespace. At the moment the only such facet is saxon:preprocess
      Specified by:
        `preprocess` in interface `SimpleType`
      Parameters:
        `input` - the value to be preprocessed
      Returns:
        the value after preprocessing

    - #### postprocess

          public java.lang.CharSequence postprocess​(java.lang.CharSequence input)
                                             throws ValidationException

      Reverse any pre-lexical facets, other than whitespace. At the moment the only such facet is saxon:preprocess. This is called when converting a value of this type to a string
      Specified by:
        `postprocess` in interface `SimpleType`
      Parameters:
        `input` - the value to be postprocessed: this is the "ordinary" result of converting the value to a string
      Returns:
        the value after postprocessing
      Throws:
        `ValidationException` - if postprocessing detects that the value is invalid

    - #### getComponentAsFunction

          public Function getComponentAsFunction()

      Get the schema component in the form of a function item. This allows schema information to be made visible to XSLT or XQuery code. The function makes available the contents of the schema component as defined in the XSD specification. The function takes a string as argument representing a property name, and returns the corresponding property of the schema component. There is also a property "class" which returns the kind of schema component, for example "Attribute Declaration".
      Specified by:
        `getComponentAsFunction` in interface `SchemaComponent`
      Returns:
        the schema component represented as a function from property names to property values.